import Pmw
import string

import ConceptNetDB,LifeNet,GoalNet,GoalNetSpreading

__version__="1.0"
__author__ = "jhe@media.mit.edu"
__url__ = 'web.media.mit.edu/~jhe/GoalNet'

class GoalNetBrowser:
    def __init__(self,ln,parent=None):
        self.ln=ln
        self.methods=GoalNetSpreading.string_heuristic

        if parent is None:
            parent= Pmw.initialise()
        self.root=parent
            
        parent.title('GoalNet Browser')

        panedWidgetOutside = Pmw.PanedWidget(parent,
                                             orient = 'vertical',
                                             hull_height = 500,
                                             hull_width = 600)
        panedWidgetOutside.add('grptop', min = 0.05)
        panedWidgetOutside.add('grpbotton',min = 0.05)

        panedWidgetOutside.pack(fill = 'both', expand = 1)
        #Get the upper group
        grptop = panedWidgetOutside.pane('grptop')
        panedWidgettop = Pmw.PanedWidget(grptop,
                                         orient = 'horizontal',
                                         hull_height = 120,
                                         hull_width = 500,
                                         )
        panedWidgettop.add('grptopleft',min=0.05)
        panedWidgettop.add('grptopright',min=0.05)

        panedWidgettop.pack(fill = 'both', expand=1)

        grptopleft=panedWidgettop.pane('grptopleft')
        self.FieldInitial=Pmw.EntryField(grptopleft,
                                         label_text='Initial',
                                         labelpos='wn',
                                         validate=None,
                                         )
        self.FieldInitial.pack(fill='x',padx=5,pady=5)

        self.FieldGoal=Pmw.EntryField(grptopleft,
                                      label_text='Goal',
                                      labelpos='wn',
                                      validate=None,
                                      )
        self.FieldGoal.pack(fill='x',padx=5,pady=5)

        botton_execute = Pmw.ButtonBox(grptopleft)
        botton_execute.pack(padx=5,pady=5)
        botton_execute.add('Execute',command=self.execute)

        grptopright=panedWidgettop.pane('grptopright')
##         self.heuristic_spreading=Pmw.OptionMenu(grptopright,
##                                                 labelpos='wn',
##                                                 label_text='Spreading heuristic',
##                                                 items=GoalNetSpreading.string_heuristic,
##                                                 command=self.spreading_change
##                                                 )
##         self.heuristic_spreading.pack(anchor='w',padx=5, pady=5)

##         self.heuristic_activation=Pmw.OptionMenu(grptopright,
##                                                  labelpos='wn',
##                                                  label_text='Activation heuristic',
##                                                  items=GoalNetSpreading.string_heuristic,
##                                                  command=self.activating_change,
##                                                  )
##         self.heuristic_activation.pack(anchor='w',padx=5,pady=5)

##         self.activation_threshold=Pmw.Counter(grptopright,
##                                               labelpos='wn',
##                                               label_text='Activation threshold',
##                                               entryfield_validate = { 'validator':'real',
##                                                                       'min':'00',
##                                                                       'max':'2000.0',
##                                                                       },
##                                               entryfield_value='100.0',
##                                               )
##         self.activation_threshold.pack(anchor='w',padx=5,pady=5)

        self.results = Pmw.ScrolledText(panedWidgetOutside.pane('grpbotton'),
             text_wrap = 'word',
             text_state = 'normal'
             )
        self.results.pack(fill = 'both', expand = 1)
        
        print "Done!"
        self.root.mainloop()

    def __new_goalnetspreading__(self):
        gn=GoalNet.GoalNet(self.ln)
        return GoalNetSpreading.GoalNetSpreading(gn)

    def spreading_change(self,id):
        pass
##        self.execute()

    def activating_change(self,id):
        pass
##        self.execute()

    def change_inital(self):
        pass
##        self.execute()

    def change_goal(self):
        pass
##        self.execute()

    def execute(self):

        initValue=self.FieldInitial.getvalue()
        if len(initValue)>0:
            initialVector=[x.strip() for x in initValue.split(',')]
        else:
            initialVector=[]

        goalValue=self.FieldGoal.getvalue()
        if len(goalValue)>0:
            goalVector=[x.strip() for x in goalValue.split(',')]
        else:
            goalVector=[]

##        print initialVector
##        print goalVector

        self.results.clear()

        if len(initialVector)>0 and len(goalVector)>0:
            gns=self.__new_goalnetspreading__()
            answer=gns.find_path(initialVector,goalVector, 
                           'all_nodes',
                           'all_nodes',
                           100.0)
##             answer=gns.find_path(initialVector,goalVector, 
##                            self.heuristic_spreading.getvalue(),
##                            self.heuristic_activation.getvalue(),
##                            string.atof(self.activation_threshold.getvalue())
##                            )
            if answer is None:
                return None


            for i in answer:
                self.results.appendtext(str(i[0])+"=>"+str(i[1])+'\n')

        elif len(initialVector)>0 and len(goalVector)==0:
            gns=self.__new_goalnetspreading__()
            answer=gns.find_next_state(initialVector,
                                       'all_nodes',
                                       'all_nodes')
            
##             answer=gns.find_next_state(initialVector,
##                                        self.heuristic_spreading.getvalue(),
##                                        self.heuristic_activation.getvalue())
            

            for i in answer:
                self.results.appendtext(str(i)+'\n')

if __name__ == '__main__':
    cn=ConceptNetDB.ConceptNetDB()
    ln=LifeNet.LifeNet(cn)
    ##gns=GoalNetSpreading.GoalNetSpreading(ln)

    my_gui=GoalNetBrowser(ln)

    
