__version__="1.0"
__author__ = "jhe@media.mit.edu"
__url__ = 'web.media.mit.edu/~jhe/GoalNet'

class __UnknownStrategy(Exception):
    def __init__(self, value):
        self.value = value
    def __str__(self):
        return repr(self.value)

def all_nodes(node,function_source,gns,direction):
    "Return all the nodes without altering the values"
    return function_source(node)

def context_directed(node,function_source,gns,direction):
    "Return only the links that are in the context of the spreading direction"
    nodes=map(lambda x:(x[0],gns.lifenet.get_conceptnet_nodes(x[0]),x[1]),\
                function_source(node))

    nodes_output={}
    for nds in nodes:
        for cn_node in nds[1]:
            if direction.has_key(cn_node[1]):
                nodes_output[nds[0]]=max(nodes_output.get(nds[0],0),\
                                         nds[2]**(1-cn_node[0]))

    return nodes_output.items()

def context_bidirectional(node,function_source,gns,direction):
    "Return only the links that are in the context of the spreading despite the direction"
    nodes=map(lambda x:(x[0],gns.lifenet.get_conceptnet_nodes(x[0]),x[1]),\
                function_source(node))

    nodes_output={}
    for nds in nodes:
        for cn_node in nds[1]:
            if gns.initialStateContext.has_key(cn_node[1]):
                nodes_output[nds[0]]=max(nodes_output.get(nds[0],0),\
                                              nds[2]**(1-cn_node[0]))
            elif gns.goalStateContext.has_key(cn_node[1]):
                nodes_output[nds[0]]=max(nodes_output.get(nds[0],0),\
                                              0.5*nds[2]**(1-cn_node[0]))

    return nodes_output.items()

def context_all(node,function_source,gns,direction):
    "Return all the nodes altering the values given the context"
    nodes=map(lambda x:(x[0],gns.lifenet.get_conceptnet_nodes(x[0]),x[1]),\
                function_source(node))

    nodes_output={}
    for nds in nodes:
        for cn_node in nds[1]:
            if gns.initialStateContext.has_key(cn_node[1]):
                nodes_output[nds[0]]=max(nodes_output.get(nds[0],0),\
                                         nds[2]**(1-cn_node[0]))
            elif gns.goalStateContext.has_key(cn_node[1]):
                nodes_output[nds[0]]=max(nodes_output.get(nds[0],0),\
                                              0.5*nds[2]**(1-cn_node[0]))
            else:
                nodes_output[nds[0]]=max(nodes_output.get(nds[0],0),\
                                              0.5*nds[2])

    return nodes_output.items()
    
