import os,re,sys,random,string,time,math
__version__ = "2.0"
__author__ = "hugo@media.mit.edu"
__url__ = 'www.conceptnet.org'
class SegregatePredicates:


    def __init__(self,pred_filename='./generalised_predicates.txt'):

        self.predicates_filename = pred_filename
        self.process_predicates()
    def filter_line(self,line):

        pred,arg1,arg2,freq,inferred = self.unpp(line)
        score = freq+inferred/2.0
        kline_relations = ['ConceptuallyRelatedTo','SuperThematicKLine','ThematicKLine']
        if score >=2 and pred not in kline_relations:
            return 1
        elif score >=2 and pred in kline_relations:
            return 2
        elif score <2 and pred not in kline_relations:
            return 3
        elif score <2 and pred in kline_relations:
            return 4
    def process_predicates(self):

        f=open(self.predicates_filename,'r')
        g1=open('predicates_concise_nonkline.txt','w')
        g2=open('predicates_concise_kline.txt','w')
        g3=open('predicates_nonconcise_nonkline.txt','w')
        g4=open('predicates_nonconcise_kline.txt','w')
        cur_line = f.readline()
        unpp,filter_line = self.unpp,self.filter_line
        while cur_line:
            if not cur_line.strip():
                continue
            if filter_line(cur_line)==1:
                g1.write(cur_line)
            elif filter_line(cur_line)==2:
                g2.write(cur_line)
            elif filter_line(cur_line)==3:
                g3.write(cur_line)
            elif filter_line(cur_line)==4:
                g4.write(cur_line)
            cur_line = f.readline()
        f.close()
        g1.close(),g2.close(),g3.close(),g4.close()
        return
    def unpp(self,pp):

        toks = pp.strip(' ()\n').split()
        pred = toks[0]
        args = ' '.join(toks[1:])[1:-1].split('" "')
        f,i = map(lambda x:int(x.split('=')[1]),args.pop().split(';')[:2])
        return pred,args[0],args[1],f,i
if __name__ == '__main__':
    import sys
    filename = './generalised_predicates.txt'
    if sys.argv[-1][-1*len('.txt'):]=='.txt':
        filename = sys.argv[-1]
    c = SegregatePredicates(filename)